#include "StdAfx.h"
#include "PadDocument.h"

#include "ScriptletConstant.h"

namespace tipuio {

PadDocument::PadDocument(void)
{
	m_PreviewDocument = NULL;
	m_PreviewRootNode = NULL;
	m_EditChanged = FALSE;
}

PadDocument::~PadDocument(void)
{
	if (m_PreviewDocument != NULL)
	{
		delete m_PreviewDocument;
		m_PreviewDocument = NULL;
	}
}
void PadDocument::SetPreviewRootNode(const char* xmlData)
{
	TiXmlDocument* docPreview = new TiXmlDocument();
	docPreview->Parse(xmlData);
	
	BOOL bSuccess = FALSE;
	USES_CONVERSION;
	TiXmlElement* pNode = docPreview->FirstChildElement();
	if (pNode)
	{
		LPCSTR pszcValue = pNode->Value();
		if (stricmp(CT2CA(SCRIPTLET_WINDOW_NODE), pszcValue) == 0)
		{
			pNode->SetValue(CT2CA(SCRIPTLET_PANEL_NODE));
		}
		SetPreviewRootNode(pNode);				
		SetPreviewDocument(docPreview);
		bSuccess = TRUE;
	}	
	if (bSuccess == FALSE)
	{
		delete docPreview;
	}
	else
	{
		this->ResetEdit();
	}
}
void PadDocument::SetPreviewDocument(TiXmlDocument* document)
{
	if (m_PreviewDocument != NULL)
	{
		delete m_PreviewDocument;
		m_PreviewDocument = NULL;
	}
	m_PreviewDocument = document;
}
void PadDocument::SetPreviewRootNode(TiXmlElement* node)
{
	m_PreviewRootNode = node;
}

};